
; Faire descendre les bulles en utilisant une sorte de bubble sort (sisi !)
; Necessite plusieurs tours pour completement faire descendre les bulles
; Retourne iy = 1 si au moins un deplacement a ete effectue...
; Detruit b,a,e,c, ix 
FALL:

	; >>> Initialiser le booleen 
	push	af
	ld	a, 0
	ld	(is_falling), a
	pop	af
	; <<< fin
	ld	ix, field	; charger l'adresse de la map
	ld	b, 7
	ld	a, 7


f_loop1:
	push	bc
	ld	e, 0
	ld	b, 12	; Que 11 car on ne fait rien tomber du plafond
f_loop2:
	push	bc
	ld	b, (ix)

	push	af
	push	bc
	push	de
	push	hl
	call	EXCHANGE_BUBBLE
	pop	hl
	pop	de
	pop	bc
	pop	af
	inc	ix	
	inc	e
	pop	bc
	djnz	f_loop2

	dec	a
	
	pop	bc
	djnz	f_loop1

	call	PRINT_FIELD
	call	FASTCOPY

	ret

is_falling:
	.db 	0

; e = x
; c = y
ECRIRE_ZERO_AU_DESSUS:
	push	de
	push	bc
	push	af
	dec	c
	ld	a, 0
	call	FIELD_SET

	pop	af
	pop	bc
	pop	de
	ret
	
; e = x
; a = y
; Or on veut
; e = x
; c = y
EXCHANGE_BUBBLE:
	ld	c, a ; Recuperer le y
	call	FIELD_GET
	cp	0
	jp	nz, ne_pas_echanger
	
	dec	c
	call	FIELD_GET
	cp	0
	jp	z, ne_pas_echanger ; Car deux 0 l'un au dessus de l'autre

echanger:
	inc	c		; Retourner sur la case du bas
	call	FIELD_SET	; Mettre la valeur de la case du haut
	dec	c		; Retourner sur la case du haut
	ld	a, 0		; Mettre 0
	call	FIELD_SET	
	push	af
	push	bc
	push	de
	push	hl
	call	PRINT_BUBBLE_FROM_INDICES
	; >>> Prevenir qu'on a deplacer une bulle
	ld	a, 1
	ld	(is_falling), a
	; <<< fin
	pop	hl
	pop	de
	pop	bc
	pop	af


ne_pas_echanger:

	ret

; Point d'entree de l'explosion
; Faut bien commencer quelques part hein !
; Ici on prendra l'emplacement du click (cette fonction est appelée sur un click)
; Puis on va exploser la bulle 
EXPLOSE:
	ld	a,(xcoord)
	call	DIVIDE_A_BY_EIGHT
	ld	e, a
	ld	a,(ycoord)
	call	DIVIDE_A_BY_EIGHT
	ld	c, a
	
	call	HAS_NEIGHBORS
	cp	0
	ret	z
	ld	a,(xcoord)
	call	DIVIDE_A_BY_EIGHT
	ld	e, a
	ld	a,(ycoord)
	call	DIVIDE_A_BY_EIGHT
	ld	c, a
	call	FIELD_GET
	ld	b, a
	cp	0
	ret	z
	; A present on a la couleur de la bulle dans b

	call	BOUM
	ret

	
	
	
; On va chercher à savoir si l'emplacement (e, c) a au moins un voisin de la meme couleur
; b = couleur a tester
; e = x
; c = y
; a = 1 si la case a au moins un voisin...
HAS_NEIGHBORS:
	; Recuperer la valeur sous le curseur
	call	FIELD_GET
	cp	0
	jp	z, false
	ld	b, a	; La valeur est dans b
	
	dec	c
	call	TEST_NEIGHBORS
	cp	1
	jp	z, true
	inc	c
	inc	c
	call	TEST_NEIGHBORS
	cp	1
	jp	z, true
	dec	c
	dec	e
	call	TEST_NEIGHBORS
	cp	1
	jp	z, true
	inc	e
	inc	e
	call	TEST_NEIGHBORS
	cp	1
	jp	z, true
	dec	e

	jp	false

	
true:
	ld	a, 1
	ret
false:
	ld	a, 0
	ret

TEST_N:
	ld	a, 1
	ret

; Tester si la couleur vaut a
TEST_NEIGHBORS:
	; >>> Tester si on est en dehors du field
	ld	a, e
	cp	0
	jp	m, tn_invalide
	cp	12
	jp	p, tn_invalide
	ld	a, c
	cp	0
	jp	m, tn_invalide
	cp	8
	jp	p, tn_invalide
	jp	tn_valide

tn_invalide:
	ld	a, 0
	ret

tn_valide:
	;dec	c
	call	FIELD_GET
	cp	b
	jp	z, tn_is_same_color

	jp	tn_is_not_same_color

tn_is_same_color:
	ld	a, 1
	ret

tn_is_not_same_color:
	ld	a, 0
	ret


	



	


; e = x
; c = y
; b contient la couleur a tester
BOUM:
	; >>> Tester si on est en dehors du field
	push	af
	ld	a, e
	cp	0
	jp	m, invalide
	cp	12
	jp	p, invalide
	ld	a, c
	cp	0
	jp	m, invalide
	cp	8
	jp	p, invalide
	jp	valide

invalide:
	pop	af
	ret

valide:
	pop	af
	; <<< Fin test

	; >>> Tester si on doit exploser la bulle
	call	FIELD_GET
	cp	b
	ret	nz
	; <<< Fin test


	; Exploser la bulle (garder la trace de la couleur dans b)
	ld	a, 0
	call	FIELD_SET

aller_en_haut:
	push	bc
	inc	c
	call	BOUM
	dec	c
	pop	bc
aller_en_bas:
	push	bc
	dec	c
	call	BOUM
	inc	c
	pop	bc
aller_a_droite:
	push	de
	inc	e
	call	BOUM
	dec	e
	pop	de
aller_a_gauche:
	push	de
	dec	e
	call	BOUM
	inc	e
	pop	de


	; TODO : Ca c'est pour eviter de bug graphiques
	push	af
	push	bc
	push	de
	push	hl
	call	PRINT_FIELD
	pop	hl
	pop	de
	pop	bc
	pop	af


	ret


IS_FINISHED:

	ld	ix, field	; charger l'adresse de la map
	ld	b, 7
	ld	a, 7


if_loop1:
	push	bc
	ld	e, 0
	ld	b, 12	
if_loop2:
	push	bc
	ld	b, (ix)

	push	af
	push	bc
	push	de
	push	hl
	ld	c, a
	call	HAS_NEIGHBORS
	cp	1
	jp	z, if_return_false
	pop	hl
	pop	de
	pop	bc
	pop	af
	inc	ix	
	inc	e
	pop	bc
	djnz	if_loop2

	dec	a
	
	pop	bc
	djnz	if_loop1

	ld	a, 1
	ret

if_return_false:
	pop	hl
	pop	de
	pop	bc
	pop	af
	pop	bc
	pop	bc
	ld	a, 0
	ret



IS_WINNER:

	ld	ix, field	; charger l'adresse de la map
	ld	b, 7
	ld	a, 7


iw_loop1:
	push	bc
	ld	e, 0
	ld	b, 12	
iw_loop2:
	push	bc
	ld	b, (ix)

	push	af
	push	bc
	push	de
	push	hl
	ld	c, a
	call	FIELD_GET
	cp	0
	jp	nz, iw_return_false
	pop	hl
	pop	de
	pop	bc
	pop	af
	inc	ix	
	inc	e
	pop	bc
	djnz	iw_loop2

	dec	a
	
	pop	bc
	djnz	iw_loop1

	ld	a, 1
	ret

iw_return_false:
	
	pop	hl
	pop	de
	pop	bc
	pop	af
	pop	bc
	pop	bc
	ld	a, 0
	ret
	

	

